#! /bin/sh
# This is a shell archive.  Remove anything before this line, then unpack
# it by saving it into a file and typing "sh file".  To overwrite existing
# files, type "sh file -c".  You can also feed this as standard input via
# unshar, or by typing "sh <file", e.g..  If this archive is complete, you
# will see the following message at the end:
#		"End of shell archive."
# Contents:  tarmail-2.3 tarmail-2.3/Makefile tarmail-2.3/README
#   tarmail-2.3/atob.c tarmail-2.3/btoa.c tarmail-2.3/chunk.c
#   tarmail-2.3/chunk.man tarmail-2.3/patchlevel.h
#   tarmail-2.3/show_help tarmail-2.3/tarmail tarmail-2.3/tarmail.man
#   tarmail-2.3/untarmail
# Wrapped by waite@riker on Sat Nov 21 13:43:32 1992
PATH=/bin:/usr/bin:/usr/ucb ; export PATH
if test ! -d 'tarmail-2.3' ; then
    echo shar: Creating directory \"'tarmail-2.3'\"
    mkdir 'tarmail-2.3'
fi
if test -f 'tarmail-2.3/Makefile' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'tarmail-2.3/Makefile'\"
else
echo shar: Extracting \"'tarmail-2.3/Makefile'\" \(912 characters\)
sed "s/^X//" >'tarmail-2.3/Makefile' <<'END_OF_FILE'
X# Version: 2.3   Last update: 11/05/92  10:28 AM  (Edition: 4)
XCC	= cc
XCFLAGS	= -O -s
XBIN	= /usr/local/tarmail-2.3/bin
XMAN	= /usr/local/tarmail-2.3/man/manl
XL	= l
XSCRIPT	= tarmail untarmail show_help
XSRC	= atob.c btoa.c chunk.c $(SCRIPT)
XMANPAGE	= tarmail.man chunk.man
XMISC	= README patchlevel.h Makefile
XOBJ	= atob.o btoa.o chunk.o
XEXE	= atob btoa chunk
XTARGET	= $(EXE) $(SCRIPT)
X
Xall:		$(TARGET)
X
Xinstall:	$(TARGET)
X		mv $(EXE) $(BIN)
X		chmod a+x $(SCRIPT)
X		cp $(SCRIPT) $(BIN)
X		make clean
X
Xman:		$(MANPAGE)
X		cd $(MAN); rm -f btoa.$(L) tarmail.$(L) chunk.$(L)
X		cp tarmail.man $(MAN)/tarmail.$(L)
X		cp tarmail.man $(MAN)/btoa.$(L)
X		cp chunk.man $(MAN)/chunk.$(L)
X		echo Now, run catman.
X
Xname:		; @echo $(MISC) $(SRC) $(MANPAGE)
X
Xshar:		; @shar $(MISC) $(SRC) $(MANPAGE) > tarmail.shar
X
X.c.o:		; $(CC) $(CFLAGS) -o $* $*.c
X
X#atob:		atob.o
X#btoa:		btoa.o
X#chunk:		chunk.o
X
Xclean:
X		rm -f *.o $(EXE) $(OBJ)
END_OF_FILE
if test 912 -ne `wc -c <'tarmail-2.3/Makefile'`; then
    echo shar: \"'tarmail-2.3/Makefile'\" unpacked with wrong size!
fi
# end of 'tarmail-2.3/Makefile'
fi
if test -f 'tarmail-2.3/README' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'tarmail-2.3/README'\"
else
echo shar: Extracting \"'tarmail-2.3/README'\" \(2435 characters\)
sed "s/^X//" >'tarmail-2.3/README' <<'END_OF_FILE'
XThis is version 2.3  of tarmail.  The original tarmail written by Paul
XRutter and Joe Orost did not have a  version attached to it and I will
Xcall it version 1.0.
X
X
XDescription:
X
X    Tarmail allows users sending files (binary, text, etc) to users on
X    remote   system by mail  reliably.  It  requires  compress utility
X    which is not distributed  in the tarmail package.
X
X
XEnhancement of 2.3 over 1.0:
X
X    Version 2.3  will  cut the  mail into smaller  pieces  and make it
X    easier to send large files.  Each piece will have its CRC attached
X    and therefore only the damaged part need retransmission.
X
X    untarmail has been modified  to check possible file  clobbering by
X    tar extraction.  Use '-m' option in  tar make it very annoying for
X    large package. If any file  exists already,  the untarmail will be
X    aborted.
X
X
XFiles:
X     README	  - this file
X     Makefile	  - version 2.3 enhancement
X     atob.c	  - same as version 1.0
X     btoa.c	  - same as version 1.0
X     chunk.c	  - version 2.3 addition
X     chunk.man	  - version 2.3 addition
X     show_help	  - version 2.3 addition, a script tool
X     tarmail	  - version 2.3 enhancement
X     tarmail.man  - rename from btoa.man and modified to reflect 2.3 features
X     untarmail	  - version 2.3 enhancement
X     patchlevel.h - added for future release and patch purpose
X
X
XEnvironment:
X
X    I have tested this package on the following BSD  systems: Pyramid,
X    Sun, and Vax without  problem. I am not  sure about system  V, you
X    tell me.
X
X
XInstallation:
X
X    (1) edit Makefile	replace BIN, MAN, L to suit your system
X    (2) make		should build programs: atob, btoa, and chunk.
X    (3) make install	after you are satisfy with it.
X
X
XNote to original authors:
X
X    I  could not find  your  network address to  have  you review this
X    enhancement.  I apologize for this.
X
XCopyright information:
X
X    I would  like to include the GNU GPL  but I dont  want  to add 18K
X    copyright stuff to a  34K release.  Anyway, this is free software,
X    i.e., use, modify, redistribute as you like.
X
X
X-__ /\\              ,,   _-_-			General Systems Group, Inc.
X  ||  \\   _         ||    /,           ;	5 Manor Parkway
X /||__||  < \, \\ \\ ||    ||      _-_  \\/\/\	Salem, NH 03079
X \||__||  /-|| || || ||   ~||     || \\ || | |	
X  ||  |, (( || || || ||    ||     ||/   || | |	Office: (603) 893-1000
X_-||-_/   \/\\ \\/\\ \\   (  -__, \\,/  \\/\\/	Email: lew@gsg.com
X  ||
END_OF_FILE
if test 2435 -ne `wc -c <'tarmail-2.3/README'`; then
    echo shar: \"'tarmail-2.3/README'\" unpacked with wrong size!
fi
# end of 'tarmail-2.3/README'
fi
if test -f 'tarmail-2.3/atob.c' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'tarmail-2.3/atob.c'\"
else
echo shar: Extracting \"'tarmail-2.3/atob.c'\" \(2483 characters\)
sed "s/^X//" >'tarmail-2.3/atob.c' <<'END_OF_FILE'
X/* atob
X * stream filter to change printable ascii from "btoa" back into 8 bit bytes
X * if bad chars, or Csums do not match: exit(1) [and NO output]
X *
X * Paul Rutter Joe Orost
X */
X
X#include <stdio.h>
X
X#define reg register
X
X#define streq(s0, s1)  strcmp(s0, s1) == 0
X
X#define times85(x)	((((((x<<2)+x)<<2)+x)<<2)+x)
X
Xlong int Ceor = 0;
Xlong int Csum = 0;
Xlong int Crot = 0;
Xlong int word = 0;
Xlong int bcount = 0;
X
Xfatal() {
X  fprintf(stderr, "bad format or Csum to atob\n");
X  exit(1);
X}
X
X#define DE(c) ((c) - '!')
X
Xdecode(c) reg c;
X{
X  if (c == 'z') {
X    if (bcount != 0) {
X      fatal();
X    } 
X    else {
X      byteout(0);
X      byteout(0);
X      byteout(0);
X      byteout(0);
X    }
X  } 
X  else if ((c >= '!') && (c < ('!' + 85))) {
X    if (bcount == 0) {
X      word = DE(c);
X      ++bcount;
X    } 
X    else if (bcount < 4) {
X      word = times85(word);
X      word += DE(c);
X      ++bcount;
X    } 
X    else {
X      word = times85(word) + DE(c);
X      byteout((int)((word >> 24) & 255));
X      byteout((int)((word >> 16) & 255));
X      byteout((int)((word >> 8) & 255));
X      byteout((int)(word & 255));
X      word = 0;
X      bcount = 0;
X    }
X  } 
X  else {
X    fatal();
X  }
X}
X
XFILE *tmp_file;
X
Xbyteout(c) reg c;
X{
X  Ceor ^= c;
X  Csum += c;
X  Csum += 1;
X  if ((Crot & 0x80000000)) {
X    Crot <<= 1;
X    Crot += 1;
X  } 
X  else {
X    Crot <<= 1;
X  }
X  Crot += c;
X  putc(c, tmp_file);
X}
X
Xmain(argc, argv) char **argv;
X{
X  reg c;
X  reg long int i;
X  char tmp_name[100];
X  char buf[100];
X  long int n1, n2, oeor, osum, orot;
X
X  if (argc != 1) {
X    fprintf(stderr,"bad args to %s\n", argv[0]);
X    exit(2);
X  }
X  sprintf(tmp_name, "/usr/tmp/atob.%x", getpid());
X  tmp_file = fopen(tmp_name, "w+");
X  if (tmp_file == NULL) {
X    fatal();
X  }
X  unlink(tmp_name); /* Make file disappear */
X  /*search for header line*/
X  for (;;) {
X    if (fgets(buf, sizeof buf, stdin) == NULL) {
X      fatal();
X    }
X    if (streq(buf, "xbtoa Begin\n")) {
X      break;
X    }
X  }
X
X  while ((c = getchar()) != EOF) {
X    if (c == '\n') {
X      continue;
X    } 
X    else if (c == 'x') {
X      break;
X    } 
X    else {
X      decode(c);
X    }
X  }
X  if (scanf("btoa End N %ld %lx E %lx S %lx R %lx\n", &n1, &n2, &oeor, &osum, &orot) != 5) {
X    fatal();
X  }
X  if ((n1 != n2) || (oeor != Ceor) || (osum != Csum) || (orot != Crot)) {
X    fatal();
X  } 
X  else {
X    /*copy OK tmp file to stdout*/;
X    fseek(tmp_file, 0L, 0);
X    for (i = n1; --i >= 0;) {
X      putchar(getc(tmp_file));
X    }
X  }
X  exit(0);
X}
END_OF_FILE
if test 2483 -ne `wc -c <'tarmail-2.3/atob.c'`; then
    echo shar: \"'tarmail-2.3/atob.c'\" unpacked with wrong size!
fi
# end of 'tarmail-2.3/atob.c'
fi
if test -f 'tarmail-2.3/btoa.c' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'tarmail-2.3/btoa.c'\"
else
echo shar: Extracting \"'tarmail-2.3/btoa.c'\" \(2269 characters\)
sed "s/^X//" >'tarmail-2.3/btoa.c' <<'END_OF_FILE'
X/* btoa: version 4.0
X * stream filter to change 8 bit bytes into printable ascii
X * computes the number of bytes, and three kinds of simple checksums
X * incoming bytes are collected into 32-bit words, then printed in base 85
X * exp(85,5) > exp(2,32)
X * the ASCII characters used are between '!' and 'u'
X * 'z' encodes 32-bit zero; 'x' is used to mark the end of encoded data.
X *
X * Paul Rutter Joe Orost
X */
X
X#include <stdio.h>
X
X#define reg register
X
X#define MAXPERLINE 78
X
Xlong int Ceor = 0;
Xlong int Csum = 0;
Xlong int Crot = 0;
X
Xlong int ccount = 0;
Xlong int bcount = 0;
Xlong int word;
X
X#define EN(c)	(int) ((c) + '!')
X
Xencode(c) reg c;
X{
X  Ceor ^= c;
X  Csum += c;
X  Csum += 1;
X  if ((Crot & 0x80000000)) {
X    Crot <<= 1;
X    Crot += 1;
X  } 
X  else {
X    Crot <<= 1;
X  }
X  Crot += c;
X
X  word <<= 8;
X  word |= c;
X  if (bcount == 3) {
X    wordout(word);
X    bcount = 0;
X  } 
X  else {
X    bcount += 1;
X  }
X}
X
Xwordout(word) reg long int word;
X{
X  if (word == 0) {
X    charout('z');
X  } 
X  else {
X    reg int tmp = 0;
X
X    if (word < 0)
X    { /* Because some don't support unsigned long */
X      tmp = 32;
X      word = word - (long)(85 * 85 * 85 * 85 * 32);
X    }
X    if (word < 0) {
X      tmp = 64;
X      word = word - (long)(85 * 85 * 85 * 85 * 32);
X    }
X    charout(EN((word / (long)(85 * 85 * 85 * 85)) + tmp));
X    word %= (long)(85 * 85 * 85 * 85);
X    charout(EN(word / (85 * 85 * 85)));
X    word %= (85 * 85 * 85);
X    charout(EN(word / (85 * 85)));
X    word %= (85 * 85);
X    charout(EN(word / 85));
X    word %= 85;
X    charout(EN(word));
X  }
X}
X
Xcharout(c) {
X  putchar(c);
X  ccount += 1;
X  if (ccount == MAXPERLINE) {
X    putchar('\n');
X    ccount = 0;
X  }
X}
X
Xmain(argc,argv)
Xchar **argv;
X{
X  reg c;
X  reg long int n;
X
X  if (argc != 1) {
X    fprintf(stderr,"bad args to %s\n", argv[0]);
X    exit(2);
X  }
X  printf("xbtoa Begin\n");
X  n = 0;
X  while ((c = getchar()) != EOF) {
X    encode(c);
X    n += 1;
X  }
X  while (bcount != 0) {
X    encode(0);
X  }
X  /* n is written twice as crude cross check*/
X  if (ccount == 0) /* ccount == 0 means '\n' just written in charout() */
X    ; /* this avoids bug in BITNET, which changes blank line to spaces */
X  else
X    putchar('\n');
X  printf("xbtoa End N %ld %lx E %lx S %lx R %lx\n", n, n, Ceor, Csum, Crot);
X  exit(0);
X}
END_OF_FILE
if test 2269 -ne `wc -c <'tarmail-2.3/btoa.c'`; then
    echo shar: \"'tarmail-2.3/btoa.c'\" unpacked with wrong size!
fi
# end of 'tarmail-2.3/btoa.c'
fi
if test -f 'tarmail-2.3/chunk.c' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'tarmail-2.3/chunk.c'\"
else
echo shar: Extracting \"'tarmail-2.3/chunk.c'\" \(6420 characters\)
sed "s/^X//" >'tarmail-2.3/chunk.c' <<'END_OF_FILE'
X/*+F***********************************************************************
X*
X* File name:	chunk.c
X*
X* Author:	Paul Lew, General Systems Group, Inc. Salem, NH
X* Created at:	04/07/88  18:40 PM
X* Last update:	10/09/92  02:43 PM  (Edition: 16)
X*
X*  Description:	This program  will  read stdin and   divide them  into
X*		"chunks"  of  20000 bytes  and  feed each  chunk to  a
X*		program.  The   program   to  be executed   should  be
X*		specified by -c 'command arg'.
X*
X*		'%' character   in  'command arg'    will be   treated
X*		specially, currently, %i will be replaced by the chunk
X*		number (starting from 1).  %b will be replaced  by the
X*		buffer size.
X*	
X* Environment:	SunOS 4.1.2
X*		SunOS 4.0.3c
X*		4.3 BSD Vax
X*		4.2 BSD Unix Pyramid (OSx 4.0)
X*
X* Usage:	chunk [-H] [-b buffer_size] [-p part] [-c 'command arg']
X*
X* Update History:
X*
X*      Date		Description					By
X*    --------	------------------------------------------------------	---
X*    04/07/88	Initial version						Lew
X*    05/19/88	Added -p options to execute command for selected parts	Lew
X*    01/05/92	Modify -p options to handle range m-n			Lew
X*    10/09/92	Clean up before distribution				Lew
X*
X* Routines included:
X*
X*	main		main program
X*	set_cmd		prepare command string, handle % specially.
X*	proc_opt	routine to set options, calls getopt()
X*	usage		routine to display help message
X*
X* Build:	cc -o chunk chunk.c getopt.o
X*
X* Example: tar -cf - | compress | chunk -c 'btoa | mail -s "part %i/10" lew'
X*
X**-F**********************************************************************/
X#include	<stdio.h>
X#include	<ctype.h>
X#define	MAXPARTS	2000
X#define	EOS		'\0'
X#define	YES		(1)
X#define	NO		(0)
X#define	when		break;case
X#define	otherwise	break;default
X
Xchar	*Version = "1.2  01/05/92  01:43 PM";
Xchar	*Author = "Paul Lew (lew@gsg.com)";
Xint	Blocksize = 20000;		/* block size for each chunk */
Xint	Part_flag = NO;			/* if YES, -p specified */
Xchar	Part [MAXPARTS];		/* each char flag one part */
Xchar	Cmd [BUFSIZ+1];			/* command buffer */
Xchar	*Cmdp = NULL;
X
Xextern	char	*malloc ();
Xextern	FILE	*popen ();
X
X/*-------------------------------------------------------------04/08/88-+
X|									|
X|	   M a i n    P r o g r a m    S t a r t s    H e r e 		|
X|									|
X+----------------------------------------------------------------------*/
Xmain (argc, argv)
Xint	argc;
Xchar	**argv;
X	{
X	FILE	*outfp;
X	char	*bufp;
X	int	n;
X	int	idx = 0;
X	int	byte_count = 0;
X
X	proc_opt (argc, argv);
X
X	if ((bufp = malloc (Blocksize)) == NULL) {
X		fprintf (stderr, "malloc %d bytes failed, aborted\n",
X			 Blocksize);
X		exit (1);
X		}
X	
X	while ((n = fread (bufp, 1, Blocksize, stdin)) > 0) {
X		byte_count += n;
X		idx++;
X		if (Cmdp == NULL) continue;	 /* estimate total chunks */
X		set_cmd (Cmd, Cmdp, idx, n);
X		if (Part_flag && idx < MAXPARTS && Part [idx] == 0) continue;
X		if ((outfp = popen (Cmd, "w")) == NULL) {
X			fprintf (stderr, "popen failed, cmd: %s, aborted\n",
X				 Cmd);
X			exit (1);
X			}
X		fwrite (bufp, 1, n, outfp);
X		pclose (outfp);
X		}
X	if (Cmdp == NULL)
X		printf ("Total %d chunks, %d bytes\n", idx, byte_count);
X	}
X
X/*-------------------------------------------------------------04/08/88-+
X|									|
X|	       set_cmd : prepare command to be executed			|
X|									|
X+----------------------------------------------------------------------*/
Xset_cmd (outp, inp, idx, n)
Xchar	*outp;
Xchar	*inp;
Xint	idx;				/* current chunk index */
Xint	n;				/* current block size */
X	{
X	char	c;
X	char	intbuf[10];
X
X	while ((c = *inp++) != EOS) {
X		if (c == '%') {
X			if ((c = *inp++) == EOS) break;
X			switch (c) {
X				case 'i':  sprintf (intbuf, "%d", idx);
X					   goto num;
X				case 'b':  sprintf (intbuf, "%d", n);
Xnum:					   strcpy (outp, intbuf);
X					   outp += strlen (intbuf);
X					   continue;
X				default:   break; /* output the char */
X				}
X			}
X		*outp++ = c;
X		}
X	*outp = EOS;
X	}
X
Xextern	char	*optarg;	/* points to start of the option */
Xextern	int	optind;		/* index of next arg to process	 */
X/*------------------------------------------------------------07/12/84--+
X|									|
X|	   proc_opt : routine to process command options		|
X|									|
X+----------------------------------------------------------------------*/
Xproc_opt (argc, argv)
Xint	argc;
Xchar	**argv;
X	{
X	register char	c;
X	int		n;
X
X	while ((c = getopt (argc, argv, "Hb:c:p:")) != EOF) {
X		switch (c) {
X		    case 'c':	Cmdp = optarg;
X				break;
X		    case 'b':	n = atoi (optarg);
X				if (n > 0) Blocksize = n;
X				break;
X		    case 'p':	set_part (optarg);
X				break;
X		    case 'H':	
X		    default:	usage (argv[0]);
X				exit (1);
X		    }
X		}
X	return (optind);		/* index to first real argument */
X	}
X
X/*-------------------------------------------------------------07/01/86-+
X|									|
X|		    usage : display help message			|
X|									|
X+----------------------------------------------------------------------*/
Xstatic usage (pname)
Xchar	*pname;			/* program name */
X	{
X	printf ("%s  Version %s\n", pname, Version);
X	printf ("%s\n", Author);
X	printf ("Usage: %s [-H] [-b nn] [-p n] [-c 'command']\n", pname);
X	printf ("where options:\n");
X	printf ("   -H       get this help message\n");
X	printf ("   -b nn    set chunk buffer to nn bytes [20000]\n");
X	printf ("   -p xxx   do cmd only for part specified in string xxx:\n");
X	printf ("            xxx may consist of a list of numbers or ranges\n");
X	printf ("            for example: 20,30,45-90,17\n");
X	printf ("   -c cmd   execute cmd foreach chunk\n");
X	printf ("            if -c not given, print # of chunks will produced\n");
X	printf ("%% in cmd:\n");
X	printf ("  '%%i'  replaced by current chunk number (index)\n");
X	printf ("  '%%b'  replaced by current chunk buffer size\n");
X	}
X
X/*-------------------------------------------------------------01/05/92-+
X|									|
X|		     set_part : set part number array			|
X|									|
X+----------------------------------------------------------------------*/
Xset_part (s)
Xchar	*s;
X	{
X	unsigned	from, to, i;
X	char		*p = s;
X	char		c;
X
X	while (*p) {
X		c = *p;
X		if (isspace(c) || c == ',') {
X			p++; continue;
X			}
X		else if (isdigit(c)) {
X			Part_flag = YES;
X			from = to = atoi(p);
X			while (isdigit(*p)) p++;
X			if (*p == '-') {
X				p++;
X				if (isdigit(*p)) {
X					to = atoi(p);
X					while (isdigit(*p)) p++;
X					}
X				}
X			for (i=from; i<=to; i++) {
X				if (i >= MAXPARTS) {
X					fprintf (stderr, "part %d too big\n",
X						 i);
X					exit (1);
X					}
X				Part [i] = 1;
X				}
X			}
X		}
X	}
END_OF_FILE
if test 6420 -ne `wc -c <'tarmail-2.3/chunk.c'`; then
    echo shar: \"'tarmail-2.3/chunk.c'\" unpacked with wrong size!
fi
# end of 'tarmail-2.3/chunk.c'
fi
if test -f 'tarmail-2.3/chunk.man' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'tarmail-2.3/chunk.man'\"
else
echo shar: Extracting \"'tarmail-2.3/chunk.man'\" \(1664 characters\)
sed "s/^X//" >'tarmail-2.3/chunk.man' <<'END_OF_FILE'
X.TH CHUNK 1 local
X.SH NAME
Xchunk \- read stdin and pipe every chunk to a program
X.SH SYNOPSIS
X.B chunk
X[-H]
X[-b buffer_size]
X[-p part_list]
X[-c 'command arg']
X.SH DESCRIPTION
X.I Chunk
Xis a filter that reads from the standard input, and output every chunk
X(certain number of bytes) into a command.  The defualt chunk size is 20000
Xbytes and can be changed by
X.I -b buffer_size
Xoption in the command line.
X.PP
XCommand line option
X.I -p part_list
Xwill execute -c command for part(s)
X.I part_list
Xonly which might consist of a list of numbers or ranges separated by ',' or
Xwhitespaces, range is composed of two numbers separated by '-', this option
Xis used to retransmit parts that failed.  More than one
X.I -p
Xoption may be specified. If no
X.I -p
Xis specified, all parts will be processed.
X.PP
XCommand line option
X.I -c
Xwill use the next argument as command to be executed for each chunk of
Xdata. You have to quote them so that the argument will be passed also.
XIf -c is not specified, chunk will output the number of chunks it will
Xproduce.
X.PP
XOne special feature in command argument is % character, it will be used
Xas a magic character where the next character will be decoded specially:
X.IP "%i"
Xwill be replace by the current chunk number.
X.IP "%b"
Xwill be replace by the buffer size.
X.PP
X.I Chunk
Xwas designed to allow
X.I tarmail
Xa big file into smaller chunks, and therefore, it was so named.
X.SH VERSION
Xchunk        Version 1.2
X.SH EXAMPLE
Xtar -cf - . | compress | \\
X.br
Xchunk -c 'bota | mail -s "tarmail (part %i/5)" lew'
X.sp
X.br
Xtar -cf - . | compress | \\
X.br
Xchunk -p2,6-9 -c 'bota | mail -s "tarmail (part %i/40)" lew'
X.SH AUTHOR
XPaul Lew, lew@gsg.com
END_OF_FILE
if test 1664 -ne `wc -c <'tarmail-2.3/chunk.man'`; then
    echo shar: \"'tarmail-2.3/chunk.man'\" unpacked with wrong size!
fi
# end of 'tarmail-2.3/chunk.man'
fi
if test -f 'tarmail-2.3/patchlevel.h' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'tarmail-2.3/patchlevel.h'\"
else
echo shar: Extracting \"'tarmail-2.3/patchlevel.h'\" \(61 characters\)
sed "s/^X//" >'tarmail-2.3/patchlevel.h' <<'END_OF_FILE'
X#define	VERSION	"2.3-p02"
X#define	DATE	"11/05/92  01:12 PM"
X
END_OF_FILE
if test 61 -ne `wc -c <'tarmail-2.3/patchlevel.h'`; then
    echo shar: \"'tarmail-2.3/patchlevel.h'\" unpacked with wrong size!
fi
# end of 'tarmail-2.3/patchlevel.h'
fi
if test -f 'tarmail-2.3/show_help' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'tarmail-2.3/show_help'\"
else
echo shar: Extracting \"'tarmail-2.3/show_help'\" \(630 characters\)
sed "s/^X//" >'tarmail-2.3/show_help' <<'END_OF_FILE'
X#! /bin/sh
X#
X#-	Show_help will extract all lines starts with '#-' in a script 
X#-	on standard output.
X#-
X#	Author:		Paul Lew, General Systems Group, Inc.
X#	Created at:	03/20/86  05:21 PM
X#	Last update:	04/22/88  05:39 PM (Edition: 7)
X#
X#-	Usage:	show_help [-H] filename <CR>
X#
Xcase "$1" in
X	-H[vV])	show_help `which $0` 1; exit;;
X	-H)	show_help `which $0` 0; exit;;
X	"")	echo '...No parameter to show_help...'; exit;;
X	*)	;;
X	esac
Xif test "$2" = "-HV" -o "$2" = "-Hv"; then
X	less $1
Xelse
X	if test ! -r "$1"; then
X		echo "...show_help: can not read file $1..."
X	else
X		sed -n -e '/^#-$/s/^..//p' -e '/^#-[^-]/s/^..//p' $1
X		fi
X	fi
END_OF_FILE
if test 630 -ne `wc -c <'tarmail-2.3/show_help'`; then
    echo shar: \"'tarmail-2.3/show_help'\" unpacked with wrong size!
fi
chmod +x 'tarmail-2.3/show_help'
# end of 'tarmail-2.3/show_help'
fi
if test -f 'tarmail-2.3/tarmail' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'tarmail-2.3/tarmail'\"
else
echo shar: Extracting \"'tarmail-2.3/tarmail'\" \(3730 characters\)
sed "s/^X//" >'tarmail-2.3/tarmail' <<'END_OF_FILE'
X#! /bin/sh
X#
X#-	tarmail - send compressed package thru mail
X#-
X#-	Tarmail will read stdin or files specified in the command line
X#-	and create a tar file, the output  is then compressed, splited
X#-	into chunks where each chunk is then mail as a unit.
X#-
X#-	Trickle  mode  will  create a sh script to be executed  in wee
X#-	hours when communication  cost is the lowest.  The script will
X#-	divide the source into chunks and only send out 20 parts a day
X#-	to avoid jamming the mail system.
X#-
X#	Author:		Paul Lew, (original author: Paul Rutter)
X#	Created at:	Unknown
X#	Last update:	10/11/92  05:01 PM  (Edition: 36)
X#
X#-	Version: 2.3
X#-
X#-	Usage:	tarmail [-b nn] [-p xxx] [-c] [-t] [-s n] [-T hh:mm]
X#-			mailpath "subject" dir-or-file(s)
X#-	where option:
X#-		-b nn		each chunk to nn bytes (default: 20000)
X#-		-T hh:mm	set trickle starting time
X#-		-s n		wait n seconds before send next parts
X#-				in trickle mode (default: 86400)
X#-		-c		dont run compress, use this if the source
X#-				files are already in tar.Z format
X#-		-t		send files in trickle mode
X#-		-p xxx		send only part specified in strings xxx (for
X#-				retransmission), xxx might consists of a list
X#-				of numbers or ranges separated by whitespaces
X#-				or ','. Range is composed of two numbers
X#-				separated by '-'.
X#-				e.g.,
X#-					-p 1 -p 4 -p 5	--- send part 1,4,5
X#-					-p 1,4,5	--- send part 1,4,5
X#-					-p 4-7,9	--- send part 4,5,6,7,9
X#
X#---------------------------------------------------------------#
X#	      Display help if requested by user			#
X#---------------------------------------------------------------#
Xprogname=$0
Xcase "$1" in
X	-H[xX])	set -x; shift;;
X	-H*)	show_help `which $0` $1; exit;;
X	*)	;;
X	esac
X#---------------------------------------------------------------#
X#		Process command line options			#
X#---------------------------------------------------------------#
Xblk=20000
Xcmp='compress'
Xcopt=''
Xtrickle=0
Xstart='23:00'
Xsleep=86400
Xwhile true; do
X	case "$1" in
X		-b)	shift; blk=$1; shift;;
X		-c)	shift; cmp='cat'; copt='-c';;
X		-t)	shift; trickle=1;;
X		-T)	shift; start=$1; shift;;
X		-s)	shift; sleep=$1; shift;;
X		-p)	shift
X			for i in $1; do
X				part="$part -p$i"
X				done
X			shift;;
X		*)	break
X		esac
X	done
X#---------------------------------------------------------------#
X#	    tar, compress, chunk, btoa, then mail		#
X#---------------------------------------------------------------#
Xif test $# -lt 3; then
X	show_help `which $progname`
X	exit
X	fi
Xtmpfile=/tmp/tarmail.$$
Xmsg='unpack with untarmail'
Xmailpath=$1
Xshift
Xsubject="$1"
Xshift
Xtar cvf - $* | $cmp > $tmpfile
Xtotal=`chunk -b $blk < $tmpfile| sed -n 's/Total \(.*\) chunk.*$/\1/p'`
X#---------------------------------------------------------------#
X#	  write a script to trickle all the parts		#
X#---------------------------------------------------------------#
Xif test $trickle -eq 1; then
X	script=$HOME/tarmail.$$
X	echo '#! /bin/sh' > $script
X	echo cd `pwd` >> $script
X	i=1
X	while [ $i -lt $total ]; do
X		j=`expr $i + 20 - 1`
X		echo tarmail $copt -p $i-$j $mailpath "'$subject'" $*
X		echo sleep $sleep
X		i=`expr $j + 1`
X		done >> $script
X	echo rm $script >> $script
X	at -s -m $start $script
X	/bin/rm $tmpfile
X	exit
X	fi
X#---------------------------------------------------------------#
X#	      normal mode, just send the files			#
X#---------------------------------------------------------------#
Xecho "Files: $*"
Xecho "To: $mailpath"
Xecho "Subject: $subject ($total parts) $part"
Xcat $tmpfile | chunk -b $blk $part \
X	-c "btoa | mail -s '$subject (part %i/$total) $msg' $mailpath"
X/bin/rm $tmpfile
X#---------------------------------------------------------------#
X#		Clean up and exit here...			#
X#---------------------------------------------------------------#
END_OF_FILE
if test 3730 -ne `wc -c <'tarmail-2.3/tarmail'`; then
    echo shar: \"'tarmail-2.3/tarmail'\" unpacked with wrong size!
fi
chmod +x 'tarmail-2.3/tarmail'
# end of 'tarmail-2.3/tarmail'
fi
if test -f 'tarmail-2.3/tarmail.man' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'tarmail-2.3/tarmail.man'\"
else
echo shar: Extracting \"'tarmail-2.3/tarmail.man'\" \(6591 characters\)
sed "s/^X//" >'tarmail-2.3/tarmail.man' <<'END_OF_FILE'
X.; Last update:  10/21/92  05:04 PM  (Edition: 3)
X.TH TARMAIL 1 local
X.SH NAME
Xtarmail, untarmail \- reliable send/receive files through mail system
X.br
Xbtoa, atob \- encode/decode binary to printable ASCII
X.SH SYNOPSIS
X.B tarmail
X[-b block_size] [-p part_number] [-c] [-t] [-s n] [-T hh:mm]
Xwho subject files ...
X.br
X.RS 8
X.TP 16
X-b \fIblock_size\fR
Xset each block to \fIblock_size\fR bytes, default 20000
X.TP 16
X-p \fIn\fR
Xsend only part \fIn\fR, e.g., -p 10, -p 10,15, -p 3-7, -p 3,7,11-14
X.TP 16
X-c
Xdont run thru compress, use for already compressed files, e.g., epoch.tar.Z
X.TP 16
X-t
Xtrickle mode
X.TP 16
X-s \fIsec\fR
Xsleep \fIsec\fR seconds between trickles
X.TP 16
X-T \fIhh:mm\fR
Xset trickle starting time to be \fIhh:mm\fR
X.RE
X.br
X.B untarmail
X[-k] [-t dir] [ files ... ]
X.RS 8
X.TP 16
X-k
Xkeep the original files instead of moving them to /usr/tmp
X.RE
X.RS 8
X.TP 16
X-t \fIdir\fR
Xuse \fIdir\fR as the temporary directory instead of the default /tmp
X.RE
X.B btoa
X.br
X.B atob
X.br
X.SH DESCRIPTION
XThe tarmail package is composed of 5 programs: \fItarmail\fR,
X\fIuntarmail\fR are the top layer programs for sending/receiving
Xpackages; \fIbtoa\fR, \fIatob\fR, and \fIchunk\fR are filters used by
Xtarmail and untarmail.  \fIChunk\fR is documented in a separated man
Xpage.  The following sections describe each program in detail.
X.SH FILTERS btoa and atob
X.I Btoa
Xis a filter that reads anything from the standard input, and encodes
Xit into printable ASCII on the standard output.  It also attaches a
Xheader and checksum information used by the reverse filter
X.I atob 
Xto find the start of the data and to check integrity.
X.PP
X.I Atob
Xreads an encoded file, strips off any leading and trailing lines added
Xby mailers, and recreates a copy of the original file on the standard
Xoutput.
X.I Atob 
Xgives NO output (and exits with an error message) if its input is
Xgarbage or the checksums do not check.
X.SH TARMAIL
X.I Tarmail
Xis a shell script that tar's up all the given files, pipes them
Xthrough
X.IR compress ","
X.IR btoa ","
Xand mails them to the given person with the given subject phrase.  For
Xexample:
X.PP
X.in 1i
Xtarmail ralph "here it is ralph" foo.c a.out
X.in -1i
X.PP
XWill package up files "foo.c" and "a.out" and mail them to "ralph"
Xusing subject "here it is ralph".  Notice the quotes on the subject.
XThey are necessary to make it one argument to the shell.
X.PP
XTarmail will pack the mail in
X.I smaller chunks
Xif the mail is too big.  The default chunk size is 20000 bytes before
Xrunning btoa, and will be some percentage bigger than that.  String
Xlike: "(part 1/5)" will be appended at the end of the subject. This
Xstring is the sole clue for untarmail to put them back in the proper
Xorder.
X.PP
XEach mail will be filtered by btoa with CRC checksum, this allows
Xindividual package be retransmitted.  The sender will have to repeat
Xthe original tarmail command with additional -p option to send out
Xonly the parts that are corrupted.  The part numbers can be specified
Xin (1) number, (2) range like m-n, or (3) list of comma separated
Xnumbers or ranges
X.PP
XTrickle mode is specified by -t flag which will create a sh script in
Xcaller's home directory and queue it for transmission when
Xcommunication cost is the lowest.  Trickle mode should be used when
Xsending large packages.  The default starting time for trickle mode is
X11 pm when the phone rate drops, it may be overrided by -T options.
XThe default interval between each trickle is one day which may be
Xoverrided by -s option.  Take precaution if you are going to override
Xthe trickle interval so it will not send out packages during regular
Xphone rate hours.
X.PP
X.I Tarmail 
Xwith no args will print a short message reminding you what the
Xrequired args are.
X.SH UNTARMAIL
XWhen the mail is received at the other end, that person should use
Xmail to save the message in some temporary file name (say "xx").  Then
Xsaying "untarmail xx" will decode the message and untar it.
X.PP
XIf you receive a tarmail with multiple mails, you should save each of
Xthem in a separate file and then feed them to untarmail, e.g.,
X.nf
X	$ untarmail perl5 perl2 perl3 perl4 perl1
X.fi
X.PP
XUntarmail will sort them in proper order.  If there is any part missed,
Xuntarmail will reject the request.
X.PP
X.I Untarmail 
Xcan also be used as a filter.  By using 
X.IR tarmail ","
Xbinary files and
Xentire directory structures can be easily transmitted between machines.
XNaturally, you should understand what tar itself does before you use 
X.IR tarmail "."
X.SH EXAMPLES:
X.IP "    \(bu"
XThe following command will send all the files under /usr/man/manl to
Xjms@x11.nt.com
X.nf
X	$ tarmail jms@x11.nt.com 'local manuals' /usr/man/manl
X.fi
X.IP "    \(bu"
XThe following command will send ghostview-1.4.tar.Z to lew@gsg.com,
Xthe -c option is used so the file will not be compressed agin:
X.nf
X	$ tarmail -c lew@gsg.com ghostview-1.4.tar.Z
X.fi
X.IP "    \(bu"
XThe following command will send epoch.tar.Z to lew@gsg.com in trickle
Xmode:
X.nf
X	$ tarmail -t -c lew@gsg.com epoch.tar.Z epoch.tar.Z
X.fi
X.IP "    \(bu"
XThe following command will send part 3 and part 7 of epoch.tar.Z to
Xlew@gsg.com:
X.nf
X	$ tarmail -p 3,7 -c lew@gsg.com epoch.tar.Z epoch.tar.Z
X.fi
X.SH OTHER USES:
X.PP
Xcompress < secrets | crypt | btoa | mail ralph
X.PP
Xwill mail the encrypted contents of the file "secrets" to ralph.  If ralph
Xknows the encryption key, he can decode it by saving the mail (say in "xx"),
Xand then running:
X.PP
Xatob < xx | crypt | uncompress
X.PP
X(crypt requests the key from the terminal,
Xand the "secrets" come out on the terminal).
X.SH VERSION
X.nf
Xtarmail		Version 2.3
Xuntarmail	Version 2.3
Xatob		Version ??
Xbtoa		Version 4.0
X.fi
X.SH AUTHOR
XPaul Rutter, original author
X.br
XPaul Lew, modified since version 2.0
X.SH FEATURES
X.I Btoa
Xuses a compact base-85 encoding so that 4 bytes are encoded into 5
Xcharacters (file is expanded by 25%).  As a special case, 32-bit zero
Xis encoded as one character.  This encoding produces less output than
X.IR uuencode "(1)."
X.SH BUGS
XUntarmail will search for string: "(part " in the subject line to
Xidentify individual parts.  Subject with "(part " in it will be
Xprocessed.  This might cause problem when untarmail a package
Xgenerated from previous version of tarmail.
X.PP
XPay extra attention to flag -\fIc\fR when resend any corrupted parts.
XIt will not work properly if the original tarmail specifies -\fIc\fR
Xoption while the resend does not.
X.SH "SEE ALSO"
Xcompress(1), crypt(1), uuencode(1), mail(1)
X.;
X.;;; Local Variables:			***
X.;;; mode: nroff			***
X.;;; ispell-filter-hook: "deroff"	***
X.;;; ispell-filter-hook-args: ("-w")	***
X.;;; End:				***
END_OF_FILE
if test 6591 -ne `wc -c <'tarmail-2.3/tarmail.man'`; then
    echo shar: \"'tarmail-2.3/tarmail.man'\" unpacked with wrong size!
fi
# end of 'tarmail-2.3/tarmail.man'
fi
if test -f 'tarmail-2.3/untarmail' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'tarmail-2.3/untarmail'\"
else
echo shar: Extracting \"'tarmail-2.3/untarmail'\" \(4164 characters\)
sed "s/^X//" >'tarmail-2.3/untarmail' <<'END_OF_FILE'
X#! /bin/sh
X#
X#-	untarmail - unpack tarmail files to recreate file structure
X#-
X#-	Untarmail  can now  handle  tarmail with more   than  one mail
X#-	message.   This is   very  useful  when  sending large package
X#-	across  phone  line.  It will  sort the files specified in the
X#-	command line by the "Subject: ... (part n/m)" before it append
X#-	them together so that incorrect file sequence will  be ok.  If
X#-	insufficient files  were given, it  will reject the operation.
X#-	For a detail description see man pages for tarmail.
X#-
X#	Author:		Paul Lew, General Systems Group, lew@gsg.com
X#	Original:	Paul Rutter
X#	Created at:	04/02/88  10:30 AM
X#	Last update:	10/11/92  10:21 PM  (Edition: 34)
X#
X#-	Version: 2.3
X#-
X#-	Usage:		untarmail [-t dir] [-k] [file1 file2 ...]    or
X#-			... | untarmail [-t dir] [-k]
X#-	where options:
X#-		-t dir	use "dir" to store temporary files, this should be
X#-			used if you have a huge tarmail file but small /tmp
X#-			space.  If not specified, "/tmp" will be used.
X#-		-k	keep old files, normally files will be moved into
X#-			/usr/tmp at the end of the untarmail.
X#
X#---------------------------------------------------------------#
X#	      Display help if requested by user			#
X#---------------------------------------------------------------#
Xcase "$1" in
X	-H[xX])	set -x; shift;;
X	-H*)	show_help `which $0` $1; exit 0;;
X	*)	;;
X	esac
Xtmproot=/tmp
Xdone=0
Xwhile [ "$done" = "0" ]; do
X	case "$1" in
X		-t)	shift; tmproot="$1"; shift;;
X		-k)	keep=1; shift;;
X		*)	done=1;;
X		esac
X	done
X#---------------------------------------------------------------#
X#	   Sort all the files by its part number		#
X#---------------------------------------------------------------#
Xfiles=$*
Xdatafile=$tmproot/$$.untarmail
Xtmpfile=$tmproot/untarmail.$$
Xif test $# -ge 1; then
X	files=$*
Xelse
X	cat > $datafile
X	files=$datafile
X	fi
Xfor file in $files; do
X	pno=`grep '^Subject: ' $file | \
X	    sed -n 's:^.*(part \([^/]*\)/\([^)]*\)).*$:\1 \2 :p'`
X	echo $pno $file
X	done |
Xsort -n > $tmpfile
Xfiles=`sed 's/.* //' $tmpfile | tr '\012' ' '`
X#---------------------------------------------------------------#
X#	check if all parts are there before unpack		#
X#---------------------------------------------------------------#
Xfno=`cat $tmpfile | wc -l`
Xpno=`sed -n '$s/^[^ ]* \([0-9]*\) .*$/\1/p' $tmpfile`
X/bin/rm $tmpfile
Xif test -n "$pno" -o $fno -gt 1; then
X	if test $pno -ne $fno; then
X		echo ...Got only $fno parts of total $pno parts, aborted...
X		/bin/rm -f $datafile
X		exit 1
X		fi
X	fi
X#---------------------------------------------------------------#
X#		Ok, go unpack them in a tarfile			#
X#---------------------------------------------------------------#
Xbad=$tmproot/bad.$$
Xtarfile=$tmproot/tarfile.$$
Xfor file in $files; do
X	if atob < $file; then continue; fi
X	echo "File $file corrupted, aborted" > $bad
X	grep '^Subject' $file >> $bad
X	break
X	done > $tarfile
Xfile $tarfile | grep -s compress
Xif test $? -eq 0; then		#it is compressed file
X	mv $tarfile $tarfile.Z
X	uncompress $tarfile.Z
X	fi
X#---------------------------------------------------------------#
X#	    if any problem, clean up and exit			#
X#---------------------------------------------------------------#
Xif [ -r $bad ]; then
X	cat $bad
X	/bin/rm -f $bad $tarfile
X	exit 1
X	fi
X#---------------------------------------------------------------#
X#       Check if any of the file exists, security check		#
X#---------------------------------------------------------------#
Xif true; then
X	tar tf $tarfile | \
X		sed 's/.*/if [ -s & ]; then echo & exist; fi/' | \
X		sh > $bad
X	fi
Xif [ -s $bad ]; then
X	echo "untarmail aborted because of possible clobbering:"
X	cat $bad
Xelse
X	tar xvpf $tarfile
X	fi
X#---------------------------------------------------------------#
X#		   move source to /usr/tmp			#
X#---------------------------------------------------------------#
Xif test "$files" = "$datafile "; then
X	/bin/rm -f $datafile
Xelse
X	if [ ! -s $bad ]; then
X		if [ "$keep" = "1" ]; then
X			echo ...You have to remove original tarmail files...
X		else
X			for file in $files; do
X				mv $file /usr/tmp/$file.$$
X				echo tarmail file moved to: /usr/tmp/$file.$$
X				done
X			fi
X		fi
X	fi
X/bin/rm -f $bad $tarfile
END_OF_FILE
if test 4164 -ne `wc -c <'tarmail-2.3/untarmail'`; then
    echo shar: \"'tarmail-2.3/untarmail'\" unpacked with wrong size!
fi
chmod +x 'tarmail-2.3/untarmail'
# end of 'tarmail-2.3/untarmail'
fi
echo shar: End of shell archive.
exit 0
